;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Example for mosaic pattern. Converters addresse offsets (hi/lo) to coordinates (y/x)
;	WRITE 5000 5826 RGBA-Mosaic-Pattern-YX.bin
;	WRITE 6000 63E7 RGBA-Mosaic-Pattern.bin

sm_width = 40

p1	= $80
x1	= $e0

pattern_hilo	= $4000
pattern_yx	= $5000
sm		= $6000

	org $2000

dl	.local
	.byte $70,$70,$70
	.byte $42,a(sm)
:24	.byte 2
	.byte $41,a(dl)
	.endl
start

	mwa #dl 560
	
	ldx #0
	lda #0
fillsm	sta sm,x
	sta sm+$100,x
	sta sm+$200,x
	sta sm+$300,x
	inx
	bne fillsm


	lda #0
	sta x1
loop

inner_loop
	jsr peek
	cmp #$fe
	beq done_all
	cmp #$ff
	beq done
	sta p1+1
	clc
	adc #>sm
	sta store+2
	jsr peek
	sta p1
	sta store+1

	ldy #0
divide	sec
	lda p1
	sbc #sm_width
	lda p1+1
	sbc #0
	bcc smaller
	iny
	sbw p1 #sm_width
	jmp divide
smaller	tya
	jsr poke_xy
	lda p1
	jsr poke_xy

	lda x1
store	sta $ffff
	jmp inner_loop

done	jsr poke_xy
	inc x1

	lda 20
	clc
	adc #2
delay	cmp 20
	bne delay
	jmp loop

done_all
	jsr poke_xy

stop	lda $d20a
	sta $d01a
	jmp stop

	.proc peek
	lda pattern_hilo
	inw peek+1
	rts
	.endp

	.proc poke_xy
	sta pattern_yx
	inw poke_xy+1
	rts
	.endp

	org pattern_hilo
	ins "RGBA-Mosaic-Pattern-HILO.bin"	;$827 bytes
	
	run start
